Index: trunk/SophyaLib/SkyMap/spherehealpix.cc
===================================================================
--- trunk/SophyaLib/SkyMap/spherehealpix.cc	(revision 843)
+++ trunk/SophyaLib/SkyMap/spherehealpix.cc	(revision 853)
@@ -126,5 +126,5 @@
 //*******************************************************************
 //++ 
-// Class	SphereHealpix
+// Class	SphereHEALPix
 //
 // include      SphereHealpix.h strutil.h
@@ -177,5 +177,5 @@
 
 template<class T>
-SphereHealpix<T>::SphereHealpix()
+SphereHEALPix<T>::SphereHEALPix()
 
 //--
@@ -187,5 +187,5 @@
 //++
 template<class T>
-SphereHealpix<T>::SphereHealpix(int_4 m)
+SphereHEALPix<T>::SphereHEALPix(int_4 m)
 
 //    m is the "nside" of the Gorski algorithm
@@ -199,6 +199,6 @@
   if(m <= 0 || m > 8192) 
     {
-      cout << "SphereHealpix : m hors bornes [0,8192], m= " << m << endl;
-      throw RangeCheckError("SphereHealpix<T>::SphereHealpix() - Out of bound nside (< 8192)!");
+      cout << "SphereHEALPix : m hors bornes [0,8192], m= " << m << endl;
+      throw RangeCheckError("SphereHEALPix<T>::SphereHEALPix() - Out of bound nside (< 8192)!");
     }
   // verifier que m est une puissance de deux 
@@ -207,6 +207,6 @@
   if(x != 1) 
     {  
-      cout<<"SphereHealpix: m doit etre une puissance de deux, m= "<<m<<endl;
-      throw ParmError("SphereHealpix<T>::SphereHealpix() - nside != 2^n !");
+      cout<<"SphereHEALPix: m doit etre une puissance de deux, m= "<<m<<endl;
+      throw ParmError("SphereHEALPix<T>::SphereHEALPix() - nside != 2^n !");
     }
   InitNul();
@@ -216,5 +216,5 @@
 //++
 template<class T>
-SphereHealpix<T>::SphereHealpix(const SphereHealpix<T>& s, bool share)
+SphereHEALPix<T>::SphereHEALPix(const SphereHEALPix<T>& s, bool share)
   : pixels_(s.pixels_, share), sliceBeginIndex_(s.sliceBeginIndex_, share), 
 				sliceLenght_(s.sliceLenght_, share)
@@ -234,5 +234,5 @@
 //++
 template<class T>
-SphereHealpix<T>::~SphereHealpix()
+SphereHEALPix<T>::~SphereHEALPix()
 
 //--
@@ -246,5 +246,5 @@
 //++
 template<class T>
-void SphereHealpix<T>::Resize(int_4 m)
+void SphereHEALPix<T>::Resize(int_4 m)
 
 //    m is the "nside" of the Gorski algorithm
@@ -256,5 +256,5 @@
 {
   if (m<=0 || m> 8192) {
-    cout << "SphereHealpix : m hors bornes [0,8192], m= " << m << endl;
+    cout << "SphereHEALPix : m hors bornes [0,8192], m= " << m << endl;
     exit(1);
   }
@@ -264,5 +264,5 @@
   if(x != 1) 
     {  
-      cout<<"SphereHealpix: m doit etre une puissance de deux, m= "<<m<<endl;
+      cout<<"SphereHEALPix: m doit etre une puissance de deux, m= "<<m<<endl;
       exit(1);
     }
@@ -273,5 +273,5 @@
 
 template<class T>
-void  SphereHealpix<T>::Pixelize( int_4 m) 
+void  SphereHEALPix<T>::Pixelize( int_4 m) 
 
 //    prépare la pixelisation Gorski (m a la même signification 
@@ -301,5 +301,5 @@
 
 template<class T>
-void SphereHealpix<T>::InitNul()
+void SphereHEALPix<T>::InitNul()
 //
 //    initialise à zéro les variables de classe 
@@ -314,5 +314,5 @@
 //++
 template<class T>
-int_4 SphereHealpix<T>::NbPixels() const
+int_4 SphereHEALPix<T>::NbPixels() const
 
 //    Retourne le nombre de pixels du découpage
@@ -324,5 +324,5 @@
 //++
 template<class T>
-uint_4 SphereHealpix<T>::NbThetaSlices() const 
+uint_4 SphereHEALPix<T>::NbThetaSlices() const 
 
 //    Return number of slices in theta direction on the  sphere
@@ -340,5 +340,5 @@
 //++
 template<class T>
-void SphereHealpix<T>::GetThetaSlice(int_4 index,r_8& theta,TVector<r_8>& phi,TVector<T>& value) const 
+void SphereHEALPix<T>::GetThetaSlice(int_4 index,r_8& theta,TVector<r_8>& phi,TVector<T>& value) const 
 
 //    For a theta-slice with index 'index', return : 
@@ -355,7 +355,7 @@
   if (index<0 || index >= NbThetaSlices()) 
     {
-      // THROW(out_of_range("SphereHealpix::PIxVal Pixel index out of range")); 
-      cout << " SphereHealpix::GetThetaSlice : Pixel index out of range" <<endl;
-      throw RangeCheckError(" SphereHealpix::GetThetaSlice : Pixel index out of range");
+      // THROW(out_of_range("SphereHEALPix::PIxVal Pixel index out of range")); 
+      cout << " SphereHEALPix::GetThetaSlice : Pixel index out of range" <<endl;
+      throw RangeCheckError(" SphereHEALPix::GetThetaSlice : Pixel index out of range");
     }
 
@@ -381,5 +381,5 @@
 
 template<class T>
-void SphereHealpix<T>::GetThetaSlice(int_4 sliceIndex,r_8& theta, r_8& phi0, TVector<int_4>& pixelIndices,TVector<T>& value) const 
+void SphereHEALPix<T>::GetThetaSlice(int_4 sliceIndex,r_8& theta, r_8& phi0, TVector<int_4>& pixelIndices,TVector<T>& value) const 
 
 //    For a theta-slice with index 'sliceIndex', return : 
@@ -398,7 +398,7 @@
   if (sliceIndex<0 || sliceIndex >= NbThetaSlices()) 
     {
-      // THROW(out_of_range("SphereHealpix::PIxVal Pixel index out of range")); 
-      cout << " SphereHealpix::GetThetaSlice : Pixel index out of range" <<endl;
-      throw RangeCheckError(" SphereHealpix::GetThetaSlice : Pixel index out of range");
+      // THROW(out_of_range("SphereHEALPix::PIxVal Pixel index out of range")); 
+      cout << " SphereHEALPix::GetThetaSlice : Pixel index out of range" <<endl;
+      throw RangeCheckError(" SphereHEALPix::GetThetaSlice : Pixel index out of range");
     }
   int_4 iring= sliceBeginIndex_(sliceIndex);
@@ -416,5 +416,5 @@
 //++
 template<class T>
-void SphereHealpix<T>::SetThetaSlices()  
+void SphereHEALPix<T>::SetThetaSlices()  
 
 //--
@@ -443,5 +443,5 @@
 //++
 template<class T>
-T& SphereHealpix<T>::PixVal(int_4 k)
+T& SphereHEALPix<T>::PixVal(int_4 k)
 
 //    Return value of  pixel with "RING" index k 
@@ -450,5 +450,5 @@
   if((k < 0) || (k >= nPix_)) 
     {
-      throw RangeCheckError("SphereHealpix::PIxVal Pixel index out of range");
+      throw RangeCheckError("SphereHEALPix::PIxVal Pixel index out of range");
     }
   return pixels_(k);
@@ -458,5 +458,5 @@
 //++
 template<class T>
-T const& SphereHealpix<T>::PixVal(int_4 k) const
+T const& SphereHEALPix<T>::PixVal(int_4 k) const
 
 //    Return value of  pixel with "RING" index k 
@@ -465,5 +465,5 @@
   if((k < 0) || (k >= nPix_)) 
     {
-      throw RangeCheckError("SphereHealpix::PIxVal Pixel index out of range");
+      throw RangeCheckError("SphereHEALPix::PIxVal Pixel index out of range");
     }
   return *(pixels_.Data()+k);
@@ -472,5 +472,5 @@
 //++
 template<class T>
-T& SphereHealpix<T>::PixValNest(int_4 k)
+T& SphereHEALPix<T>::PixValNest(int_4 k)
 
 //    Return value of  pixel with "NESTED" index k 
@@ -479,5 +479,5 @@
   if((k < 0) || (k >= nPix_)) 
     { 
-      throw RangeCheckError("SphereHealpix::PIxValNest Pixel index out of range");
+      throw RangeCheckError("SphereHEALPix::PIxValNest Pixel index out of range");
     }
   return pixels_(nest2ring(nSide_,k));
@@ -486,5 +486,5 @@
 
 template<class T>
-T const& SphereHealpix<T>::PixValNest(int_4 k) const
+T const& SphereHEALPix<T>::PixValNest(int_4 k) const
 
 //    Return value of  pixel with "NESTED" index k 
@@ -493,5 +493,5 @@
   if((k < 0) || (k >= nPix_)) 
     { 
-      throw RangeCheckError("SphereHealpix::PIxValNest Pixel index out of range");
+      throw RangeCheckError("SphereHEALPix::PIxValNest Pixel index out of range");
   }
   int_4 pix= nest2ring(nSide_,k);
@@ -502,5 +502,5 @@
 //++
 template<class T>
-bool SphereHealpix<T>::ContainsSph(double /*theta*/, double /*phi*/) const
+bool SphereHEALPix<T>::ContainsSph(double /*theta*/, double /*phi*/) const
 //--
 {
@@ -511,5 +511,5 @@
 //++
 template<class T>
-int_4 SphereHealpix<T>::PixIndexSph(double theta,double phi) const
+int_4 SphereHEALPix<T>::PixIndexSph(double theta,double phi) const
 
 //    Return "RING" index of the pixel corresponding to 
@@ -522,5 +522,5 @@
 //++
 template<class T>
-int_4 SphereHealpix<T>::PixIndexSphNest(double theta,double  phi) const
+int_4 SphereHEALPix<T>::PixIndexSphNest(double theta,double  phi) const
 
 //    Return "NESTED" index of the pixel corresponding to 
@@ -535,5 +535,5 @@
 //++
 template<class T>
-void SphereHealpix<T>::PixThetaPhi(int_4 k,double& theta,double& phi) const
+void SphereHEALPix<T>::PixThetaPhi(int_4 k,double& theta,double& phi) const
 
 //   Return (theta,phi) coordinates of middle of  pixel with "RING" index k
@@ -544,5 +544,5 @@
 
 template <class T>
-T SphereHealpix<T>::SetPixels(T v)
+T SphereHEALPix<T>::SetPixels(T v)
 {
 pixels_.Reset(v);
@@ -552,5 +552,5 @@
 //++
 template<class T>
-double SphereHealpix<T>::PixSolAngle(int_4 /*dummy*/) const
+double SphereHEALPix<T>::PixSolAngle(int_4 /*dummy*/) const
 //    Pixel Solid angle  (steradians)
 //    All the pixels have the same solid angle. The dummy argument is
@@ -564,5 +564,5 @@
 //++
 template<class T>
-void SphereHealpix<T>::PixThetaPhiNest(int_4 k,double& theta,double& phi) const
+void SphereHEALPix<T>::PixThetaPhiNest(int_4 k,double& theta,double& phi) const
 
 //   Return (theta,phi) coordinates of middle of  pixel with "NESTED" index k
@@ -574,5 +574,5 @@
 //++
 template<class T>
-int_4 SphereHealpix<T>::NestToRing(int_4 k) const
+int_4 SphereHEALPix<T>::NestToRing(int_4 k) const
 
 //    translation from NESTED index  into RING index 
@@ -585,5 +585,5 @@
 //++
 template<class T>
-int_4 SphereHealpix<T>::RingToNest(int_4 k) const
+int_4 SphereHEALPix<T>::RingToNest(int_4 k) const
 //
 //    translation from  RING index  into NESTED index 
@@ -596,5 +596,5 @@
 
 template<class T>
-int_4 SphereHealpix<T>::nest2ring(int_4 nside, int_4 ipnest) const 
+int_4 SphereHEALPix<T>::nest2ring(int_4 nside, int_4 ipnest) const 
 {
   /*
@@ -678,5 +678,5 @@
 
 template<class T>
-int_4 SphereHealpix<T>::ring2nest(int_4 nside, int_4 ipring) const 
+int_4 SphereHEALPix<T>::ring2nest(int_4 nside, int_4 ipring) const 
 {
   /*
@@ -787,5 +787,5 @@
 
 template<class T>
-int_4 SphereHealpix<T>::ang2pix_ring(int_4 nside, double theta, double phi) const 
+int_4 SphereHEALPix<T>::ang2pix_ring(int_4 nside, double theta, double phi) const 
 {
   /*
@@ -863,5 +863,5 @@
 
 template<class T>
-int_4 SphereHealpix<T>::ang2pix_nest(int_4 nside, double theta, double phi) const 
+int_4 SphereHEALPix<T>::ang2pix_nest(int_4 nside, double theta, double phi) const 
 {
   /*
@@ -960,5 +960,5 @@
 
 template<class T>
-void SphereHealpix<T>::pix2ang_ring(int_4 nside,int_4 ipix,double& theta,double& phi) const {
+void SphereHEALPix<T>::pix2ang_ring(int_4 nside,int_4 ipix,double& theta,double& phi) const {
   /*
     ===================================================
@@ -1028,5 +1028,5 @@
 
 template<class T>
-void SphereHealpix<T>::pix2ang_nest(int_4 nside,int_4 ipix,double& theta,double& phi) const {
+void SphereHEALPix<T>::pix2ang_nest(int_4 nside,int_4 ipix,double& theta,double& phi) const {
   /*
     ==================================================
@@ -1119,5 +1119,5 @@
 
 template <class T>
-void SphereHealpix<T>::print(ostream& os) const
+void SphereHEALPix<T>::print(ostream& os) const
 {
   if(mInfo_) os << "  DVList Info= " << *mInfo_ << endl;
@@ -1152,16 +1152,16 @@
 
 #ifdef __CXX_PRAGMA_TEMPLATES__
-#pragma define_template SphereHealpix<uint_2>
-#pragma define_template SphereHealpix<r_8>
-#pragma define_template SphereHealpix<r_4>
-#pragma define_template SphereHealpix< complex<r_4> >
-#pragma define_template SphereHealpix< complex<r_8> >
+#pragma define_template SphereHEALPix<uint_2>
+#pragma define_template SphereHEALPix<r_8>
+#pragma define_template SphereHEALPix<r_4>
+#pragma define_template SphereHEALPix< complex<r_4> >
+#pragma define_template SphereHEALPix< complex<r_8> >
 #endif
 #if defined(ANSI_TEMPLATES) || defined(GNU_TEMPLATES)
-template class SphereHealpix<uint_2>;
-template class SphereHealpix<r_8>;
-template class SphereHealpix<r_4>;
-template class SphereHealpix< complex<r_4> >;
-template class SphereHealpix< complex<r_8> >;
+template class SphereHEALPix<uint_2>;
+template class SphereHEALPix<r_8>;
+template class SphereHEALPix<r_4>;
+template class SphereHEALPix< complex<r_4> >;
+template class SphereHEALPix< complex<r_8> >;
 #endif
 