Index: trunk/SophyaExt/FitsIOServer/fitsfile.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 861)
+++ trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 867)
@@ -241,5 +241,4 @@
   void FitsFile::GetBinTabFCol(double* valeurs,int nentries, int NoCol) const
     {
-      cout << "entree getbintablefcol double" << endl;
       int status= 0;
       int DTYPE;
@@ -254,8 +253,6 @@
       int    anull;
       float dnull= 0.;
-      cout << " avant lecture  colonne, nels= " << nels << endl;
       fits_read_col(fptr_,TDOUBLE,NoCol+1,1,1,nels,&dnull,valeurs,
 			    &anull,&status);
-      cout << "  colonne lue" << endl;
       if( status ) printerror( status,"erreur lecture de colonne" );
     }
@@ -263,5 +260,4 @@
   void FitsFile::GetBinTabFCol(float* valeurs,int nentries, int NoCol) const
     {
-      cout << "entree getbintablefcol float" << endl;
       int status= 0;
       int DTYPE;
@@ -282,5 +278,4 @@
   void FitsFile::GetBinTabFCol(int* valeurs,int nentries, int NoCol) const
     {
-      cout << "entree getbintablefcol int" << endl;
       int status= 0;
       int DTYPE;
@@ -298,10 +293,7 @@
 			    &anull,&status);
       if( status ) printerror( status,"erreur lecture de colonne" );
-      cout << " tableau d'entiers relu: " << endl;
-      for (int ijk=0; ijk<nels;ijk++) cout << valeurs[ijk] << endl;
     }
   void FitsFile::GetBinTabFCol(char** valeurs, int nentries, int NoCol) const
     {
-      cout << "entree getbintablefcol string" << endl;
       int status= 0;
       int DTYPE;
@@ -312,5 +304,4 @@
 	  throw IOExc("FitsFile::GetBinTabFCol, tentative de lecture non float");
 	}
-      cout << " repeat= " << repeat << " width= " << width << endl;
       long nels=nentries;
       // no checking for undefined pixels
@@ -319,11 +310,7 @@
       long frow=1;
       long felem=1;
-      cout << " nb elements a lire" << nels << endl;
-      cout << " taille element tableau " << strlen(valeurs[0]) << endl;
-      cout << " numero de colonne a lire: " << NoCol+1 << endl;
       fits_read_col(fptr_,TSTRING,NoCol+1,frow,felem,nels,cnull,valeurs,
 		    &anull,&status);
       if( status ) printerror( status,"erreur lecture de colonne" );
-      cout << " fin lecture chaines" << endl;
     }
 int  FitsFile::NbColsFromFits() const
@@ -458,5 +445,4 @@
 	  taille_des_chaines_.push_back(width);
 	  rept/=width;
-	  cout << " j'ai lu  taille_des_chaines= " << width << " rept= " << rept << endl;
 	  break;
 	default :
@@ -466,5 +452,4 @@
       //    nentries = max(nentries, nrows_*rept);
       repeat_.push_back(rept);
-      cout << " getparam: repeat= " << repeat_[ii] << endl;
     } 
   // get number of keywords
@@ -525,13 +510,10 @@
 	}
     } 
-  cout << " fin lecture du dvlist : " << endl;
-  dvl_.Print();
+  //  dvl_.Print();
 }
 void FitsFile::makeHeaderBntblOnFits( char* fieldType, char** Noms, int nentries, int tfields, DVList &dvl, char* extname, vector<int> taille_des_chaines) const
 { 
-  cout << " entree put_column_bntbl " << endl;
   int status = 0;
   long nrows;
-  cout << " nombre de types: " << strlen(fieldType) << endl;
   if (strlen(fieldType) != tfields)
     {
@@ -574,6 +556,4 @@
 	  else strcpy(format,"1024");
 	}
-      cout << " en ecriture fits : nrows= " << nrows << endl;
-      cout << " fitsfile : format= " << format << endl;
       strncat(format,&fieldType[k],1);
       if (fieldType[k] == 'A') 
@@ -581,5 +561,4 @@
 	  strcat(format,largeur);
 	}
-      cout << " fitsfile : format= " << format << endl;
       ttype[k]= new char[FLEN_VALUE];
       strcpy(ttype[k],Noms[k]);
@@ -596,5 +575,4 @@
   // so the NULL pointer is given for the tunit parameters.
   nrows=0;
-      cout << " en ecriture fits : nrows avant create = " << nrows << endl;
   fits_create_tbl(fptr_,BINARY_TBL,nrows,tfields,ttype,tform,
 		  NULL,extn,&status);
@@ -612,6 +590,5 @@
   //
   // get names and values from the join DVList object
-  cout << " dvlist en ecriture..." << endl;
-  dvl.Print();
+  //  dvl.Print();
   DVList::ValList::const_iterator it;
   for(it = dvl.Begin(); it != dvl.End(); it++)
@@ -621,5 +598,4 @@
       strncpy(keyname,(*it).first.substr(0,64).c_str(),10);
       char comment[FLEN_COMMENT];
-      cout << " keyname: " << keyname << " keytype: " << keytype << endl;
       switch (keytype)
 	{
@@ -629,5 +605,4 @@
 	    strcpy(comment,"I entier");
 	    fits_write_key(fptr_,TINT,keyname,&ival,comment,&status);
-	    cout << " keyname " << keyname << " = " << ival << " ecrit " << endl;
 	    break;
 	  }
@@ -637,5 +612,4 @@
 	    strcpy(comment,"D double");
 	    fits_write_key(fptr_,TDOUBLE,keyname,&dval,comment,&status);
-	    cout << " keyname " << keyname << " = " << dval << " ecrit " << endl;
 	    break;
 	  }
@@ -646,5 +620,4 @@
 	    strcpy(comment,"S character string");
 	    fits_write_key(fptr_,TSTRING,keyname,&strval,comment,&status);
-	    cout << " keyname " << keyname << " = " << strval << " ecrit " << endl;
 	    break;
 	  }
@@ -653,5 +626,4 @@
     }
 
-  cout << " fitsfile: le dvlist est ecrit" << endl;
 }
 
@@ -663,9 +635,9 @@
   if( status ) printerror(status,"putColToFits: le movabs a foire");
   fits_get_hdu_type(fptr_, &hdutype, &status);
-  if(hdutype != ASCII_TBL && hdutype != BINARY_TBL)
-    {
-      cout << " hdunum= " << hdunum_ << " hdutype= " << hdutype << endl;
-  //   throw IOExc("FitsFile::putColToFits, this HDU is not an ASCII table nor a binary table");
-    }
+    if(hdutype != ASCII_TBL && hdutype != BINARY_TBL)
+        {
+            cout << " hdunum= " << hdunum_ << " hdutype= " << hdutype << endl;
+     throw IOExc("FitsFile::putColToFits, this HDU is not an ASCII table nor a binary table");
+          }
   //  if(hdutype == ASCII_TBL && nocol>0)
   //  {