Index: trunk/SophyaExt/FitsIOServer/fitsntuple.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsntuple.cc	(revision 867)
+++ trunk/SophyaExt/FitsIOServer/fitsntuple.cc	(revision 873)
@@ -56,5 +56,4 @@
   int nbcols, nbentries;
   nbcols = fn.NbColsFromFits();
-  cout << " nbcols= " << nbcols << endl;
   nbentries = 0;
   for (int k=0; k<nbcols; k++) nbentries=max( nbentries, fn.NentriesFromFits(k) );
@@ -99,5 +98,4 @@
     }
   delete [] ColName;
-  cout << " preparation du tabeau column" << endl;
     if (column_ != NULL) delete [] column_;
     column_ = new float[nbentries];
@@ -105,18 +103,12 @@
   // j'initialise le NTuple a zero, pour le dimensionner
   // (SetVal suppose que le ntuple est deja dimensionne)
-  cout << " nbcol= " << nbcols << endl;
   r_4* ligne = new r_4[nbcols];
     for (int k=0; k<nbcols; k++) ligne[k]=0.;
     for (int k=0; k<nbentries;k++) dobj_->Fill(ligne);
-  cout << " ntuple initialise a zero" << endl;
     delete [] ligne;
-   cout << "debut boucle nbcol= " << nbcols << endl;
   for (int k=0; k<nbcols;k++) 
     {
-      cout << " avant lecture col. no " << k << endl;
       fn.GetBinTabFCol(column_, nbentries, k);
-      cout << " lecture effectuee " << endl;
       for (int nent=0; nent<nbentries; nent++) dobj_->SetVal(nent,k, column_[nent]);
-      cout << " valeurs inserre dans ntuple " << endl;
     }
   dobj_->Info()=fn.DVListFromFits();
@@ -147,5 +139,4 @@
       Noms[k]= new char[LONNOM1];
       strncpy(Noms[k],dobj_->NomIndex(k),LONNOM1);
-      cout << " nom entre dans ntuple: " << Noms[k] << endl;
     }
   // la librairie fitsio ecrit colonne par colonne 
@@ -163,5 +154,4 @@
    for (int k=0; k<ncols;k++) putColToFits(k, nentries, getColFromObj(k));
 
-   cout << " fin d'ecriture "<< endl; 
 }
 
Index: trunk/SophyaExt/FitsIOServer/fitsspherehealpix.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsspherehealpix.cc	(revision 867)
+++ trunk/SophyaExt/FitsIOServer/fitsspherehealpix.cc	(revision 873)
@@ -96,5 +96,4 @@
   strncpy(extname,dvl.GetS("EXTNAME").c_str(),15);
 
-  cout << " nom entre dans sphereHealpix: " << Noms[0] << endl;
   char Type[2];
   if (strncmp( typeid(T).name(),"r_8",3)==0 || strncmp( typeid(T).name(),"double",6)==0 ) Type[0]='D';
@@ -133,5 +132,5 @@
   //   const DVList* dvl = &fn.DVListFromFits();
   DVList dvl=fn.DVListFromFits();
-  dvl.Print();
+  //  dvl.Print();
    nbentries = fn.NentriesFromFits(0);
   int lastpix=dvl.GetI("LASTPIX");
@@ -174,13 +173,10 @@
   if (nPix != nbentries)
     {
-      cout << " le nombre de pixels relu " << nbentries << " est incoherent avec la pixelisation Healpix qui donne nPix= " << nPix << endl; 
+      cout << "WARNING: le nombre de pixels relu " << nbentries << " est incoherent avec la pixelisation Healpix qui donne nPix= " << nPix << endl; 
       }
   double Omega= 4.0*Pi/nPix;
   dobj_->setParameters(nside,nPix,Omega);
-  cout << " sphere Healpix : las parametres sont introduits" << endl; 
   // On lit les DataBlocks;
-  cout << "nside= " << nside << "nPix= " << nPix << endl;
   dobj_->pixels_.ReSize(nPix);
-  cout << " sphere Healpix : resize fait" << endl; 
   fn.GetSingleColumn(dobj_->pixels_.Data(),nPix);
 
Index: trunk/SophyaExt/FitsIOServer/fitstarray.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitstarray.cc	(revision 867)
+++ trunk/SophyaExt/FitsIOServer/fitstarray.cc	(revision 873)
@@ -99,10 +99,10 @@
       throw PException(" FITS_TARRAY: number of dimensions of the array = 0?");
     }
-  cout << "FITS_TARRAY: nombrede dimension du tableau a ecrire: " << nbdim << endl;
+  cout << "FITS_TARRAY: nombre de dimension du tableau a ecrire: " << nbdim << endl;
   int* naxisn = new int[nbdim];
   for (int k=0; k< nbdim; k++)
     {
       naxisn[k] = dobj_->Size(k);
-      cout << " taille de la dimension " << k << " : " << naxisn[k] << endl;
+      cout << " nombre de donnees dans la la dimension " << k << " : " << naxisn[k] << endl;
     }
   char type;
Index: trunk/SophyaExt/FitsIOServer/fitsxntuple.cc
===================================================================
--- trunk/SophyaExt/FitsIOServer/fitsxntuple.cc	(revision 867)
+++ trunk/SophyaExt/FitsIOServer/fitsxntuple.cc	(revision 873)
@@ -73,8 +73,6 @@
   int nbcols, nbentries;
   nbcols = fn.NbColsFromFits();
-  cout << " nbcols= " << nbcols << endl;
   nbentries = 0;
   for (int k=0; k<nbcols; k++) nbentries=max( nbentries, fn.NentriesFromFits(k) );
-  cout << " nbentries= " << nbentries << endl;
 
   //
@@ -148,5 +146,4 @@
   // j'initialise le NTuple a zero, pour le dimensionner
   // (SetXVal suppose que le ntuple est deja dimensionne)
-  cout << " nbcol= " << nbcols << endl;
   r_8* dligne;
   r_4* fligne;
@@ -155,5 +152,4 @@
   if (DfitsCol.size()>0) 
     {
-      cout << " preparation du tabeau dcolumn" << endl;
       if (dcolumn_ != NULL) delete [] dcolumn_;
       dcolumn_ = new double[nbentries];
@@ -164,5 +160,4 @@
   if (FfitsCol.size()>0) 
     {
-      cout << " preparation du tabeau fcolumn" << endl;
       if (fcolumn_ != NULL) delete [] fcolumn_;
       fcolumn_ = new float[nbentries];
@@ -173,5 +168,4 @@
   if (IfitsCol.size()>0) 
     {
-      cout << " preparation du tabeau icolumn" << endl;
       if (icolumn_ != NULL) delete [] icolumn_;
       icolumn_ = new int[nbentries];
@@ -182,5 +176,4 @@
   if (SfitsCol.size()>0) 
     {
-      cout << " preparation du tabeau ccolumn" << endl;
       if (ccolumn_ != NULL)
 	{
@@ -192,5 +185,4 @@
       int  taille_des_chaines=0;
       for (int k=0; k< SfitsCol.size(); k++)  taille_des_chaines = max( taille_des_chaines, fn.ColStringLengthFromFits(SfitsCol[k]) );
-      cout << " xntu: je dimensionne a taille_des_chaines= " << taille_des_chaines << endl;
       for (int k=0; k<nbentries;k++) ccolumn_[k]= new char[taille_des_chaines+1];
       cligne = new char*[SfitsCol.size()];
@@ -200,5 +192,4 @@
 
   for (int k=0; k<nbentries;k++) dobj_->Fill(dligne, fligne, iligne, cligne);
-  cout << " ntuple initialise a zero" << endl;
   delete [] dligne;
   delete [] fligne;
@@ -232,9 +223,7 @@
     {
       fn.GetBinTabFCol(ccolumn_,nbentries, SfitsCol[k]);
-      cout << " chaine recue par xntuple " << endl;
             for (int nent=0; nent<nbentries; nent++) dobj_->SetSVal(nent,compt, ccolumn_[nent]);
       compt++;
     }
-      cout << " valeurs inserees dans xntuple " << endl;
   dobj_->Info()=fn.DVListFromFits();
 
@@ -262,5 +251,4 @@
       Noms[k]= new char[LONNOM+1];
       strncpy(Noms[k],dobj_->NomIndex(k).c_str(),LONNOM+1);
-      cout << " nom entre dans ntuple: " << Noms[k] << endl;
     }
    char* types=new char[ncols+1];
@@ -314,18 +302,5 @@
       compt++;
     }
-   cout << " fin d'ecriture "<< endl; 
-}
-/* 
-void* FITS_XNTuple::getColFromObj(int colNr)
-{
-  if (colNr < dobj_->NDVar()) return (void*)getColDFromObj(colNr);
-  else 
-    if (colNr < dobj_->NDVar()+dobj_->NFVar())  return (void*)getColFFromObj(colNr);
-    else
-      if (colNr < dobj_->NDVar()+dobj_->NFVar()+dobj_->NIVar()) return (void*)getColIFromObj(colNr);
-      else  return (void*)getColSFromObj(colNr);
-	
-}
-*/
+}
 double* FITS_XNTuple::getColDFromObj(int colNr)
 {
@@ -377,6 +352,4 @@
       ccolumn_[j] = new char[dobj_->mStrSz+1];
       strcpy(ccolumn_[j],s.c_str());
-      //      ccolumn_[j][strlen(ccolumn_[j])-1]='\0';
-      cout << " chaine envoyee xntuple: " << ccolumn_[j] << " longueur " << strlen( ccolumn_[j]) << endl;
     }
   return ccolumn_; 